"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isAsyncDefaultValue = exports.hasAsyncDefaultValues = exports.hasAsyncFunction = void 0;
function hasAsyncFunction(instructionNode, resolvedInputs, asyncResolvers) {
    var _a, _b;
    const isBytesCreatedOnChainAsync = ((_a = instructionNode.bytesCreatedOnChain) === null || _a === void 0 ? void 0 : _a.kind) === 'resolver' &&
        asyncResolvers.includes(instructionNode.bytesCreatedOnChain.name);
    const isRemainingAccountAsync = ((_b = instructionNode.remainingAccounts) === null || _b === void 0 ? void 0 : _b.kind) === 'resolver' &&
        asyncResolvers.includes(instructionNode.remainingAccounts.name);
    return (hasAsyncDefaultValues(resolvedInputs, asyncResolvers) ||
        isBytesCreatedOnChainAsync ||
        isRemainingAccountAsync);
}
exports.hasAsyncFunction = hasAsyncFunction;
function hasAsyncDefaultValues(resolvedInputs, asyncResolvers) {
    return resolvedInputs.some((input) => !!input.defaultsTo &&
        isAsyncDefaultValue(input.defaultsTo, asyncResolvers));
}
exports.hasAsyncDefaultValues = hasAsyncDefaultValues;
function isAsyncDefaultValue(defaultsTo, asyncResolvers) {
    switch (defaultsTo.kind) {
        case 'pda':
            return true;
        case 'resolver':
            return asyncResolvers.includes(defaultsTo.name);
        case 'conditional':
        case 'conditionalResolver':
            if (defaultsTo.kind === 'conditionalResolver' &&
                asyncResolvers.includes(defaultsTo.resolver.name)) {
                return true;
            }
            return ((defaultsTo.ifFalse == null
                ? false
                : isAsyncDefaultValue(defaultsTo.ifFalse, asyncResolvers)) ||
                (defaultsTo.ifTrue == null
                    ? false
                    : isAsyncDefaultValue(defaultsTo.ifTrue, asyncResolvers)));
        default:
            return false;
    }
}
exports.isAsyncDefaultValue = isAsyncDefaultValue;
//# sourceMappingURL=asyncHelpers.js.map