"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAccountFetchHelpersFragment = void 0;
const common_1 = require("./common");
function getAccountFetchHelpersFragment(scope) {
    const { accountNode, typeManifest, nameApi } = scope;
    const decoderFunctionFragment = accountNode.data.link
        ? typeManifest.decoder.clone()
        : (0, common_1.fragment)(`${nameApi.decoderFunction(accountNode.data.name)}()`);
    return (0, common_1.fragmentFromTemplate)('accountFetchHelpers.njk', {
        decoderFunction: decoderFunctionFragment.render,
        accountType: nameApi.accountType(accountNode.name),
        decodeFunction: nameApi.accountDecodeFunction(accountNode.name),
        fetchFunction: nameApi.accountFetchFunction(accountNode.name),
        safeFetchFunction: nameApi.accountSafeFetchFunction(accountNode.name),
        fetchAllFunction: nameApi.accountFetchAllFunction(accountNode.name),
        safeFetchAllFunction: nameApi.accountSafeFetchAllFunction(accountNode.name),
    })
        .mergeImportsWith(decoderFunctionFragment)
        .addImports('solanaAddresses', ['Address'])
        .addImports('solanaAccounts', [
        'assertAccountExists',
        'decodeAccount',
        'EncodedAccount',
        'fetchEncodedAccount',
        'fetchEncodedAccounts',
        'FetchAccountConfig',
        'FetchAccountsConfig',
    ]);
}
exports.getAccountFetchHelpersFragment = getAccountFetchHelpersFragment;
//# sourceMappingURL=accountFetchHelpers.js.map