"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAccountTypeFragment = void 0;
const common_1 = require("./common");
const typeWithCodec_1 = require("./typeWithCodec");
function getAccountTypeFragment(scope) {
    const { accountNode, typeManifest, nameApi } = scope;
    const typeWithCodecFragment = accountNode.data.link
        ? (0, common_1.fragment)('')
        : (0, typeWithCodec_1.getTypeWithCodecFragment)({
            name: accountNode.data.name,
            manifest: typeManifest,
            nameApi,
        });
    const dataNameFragment = accountNode.data.link
        ? typeManifest.strictType.clone()
        : (0, common_1.fragment)(nameApi.dataType(accountNode.data.name));
    return (0, common_1.fragmentFromTemplate)('accountType.njk', {
        accountType: nameApi.accountType(accountNode.name),
        dataName: dataNameFragment.render,
        typeWithCodec: typeWithCodecFragment,
    })
        .mergeImportsWith(dataNameFragment, typeWithCodecFragment)
        .addImports('solanaAccounts', 'Account');
}
exports.getAccountTypeFragment = getAccountTypeFragment;
//# sourceMappingURL=accountType.js.map