"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getInstructionBytesCreatedOnChainFragment = void 0;
const common_1 = require("./common");
function getInstructionBytesCreatedOnChainFragment(scope) {
    const bytes = scope.instructionNode.bytesCreatedOnChain;
    if (!bytes)
        return (0, common_1.fragment)('');
    const isAsync = (bytes === null || bytes === void 0 ? void 0 : bytes.kind) === 'resolver' && scope.asyncResolvers.includes(bytes.name);
    if (!scope.useAsync && isAsync)
        return (0, common_1.fragment)('');
    const awaitKeyword = scope.useAsync && isAsync ? 'await ' : '';
    const bytesFragment = (0, common_1.fragmentFromTemplate)('instructionBytesCreatedOnChain.njk', { bytes, awaitKeyword, nameApi: scope.nameApi });
    if (bytes && 'includeHeader' in bytes && bytes.includeHeader) {
        bytesFragment.addImports('solanaAccounts', 'BASE_ACCOUNT_SIZE');
    }
    if ((bytes === null || bytes === void 0 ? void 0 : bytes.kind) === 'account') {
        const functionName = scope.nameApi.accountGetSizeFunction(bytes.name);
        const importFrom = bytes.importFrom === 'generated' ? 'generatedAccounts' : bytes.importFrom;
        bytesFragment.addImports(importFrom, functionName);
    }
    else if ((bytes === null || bytes === void 0 ? void 0 : bytes.kind) === 'resolver') {
        const functionName = scope.nameApi.resolverFunction(bytes.name);
        bytesFragment.addImports(bytes.importFrom, functionName);
        bytesFragment.addFeatures(['instruction:resolverScopeVariable']);
    }
    return bytesFragment;
}
exports.getInstructionBytesCreatedOnChainFragment = getInstructionBytesCreatedOnChainFragment;
//# sourceMappingURL=instructionBytesCreatedOnChain.js.map