"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getInstructionDataFragment = void 0;
const common_1 = require("./common");
const typeWithCodec_1 = require("./typeWithCodec");
function getInstructionDataFragment(scope) {
    const { instructionNode, dataArgsManifest, nameApi } = scope;
    if (instructionNode.dataArgs.struct.fields.length === 0 ||
        !!instructionNode.dataArgs.link) {
        return (0, common_1.fragment)('');
    }
    return (0, typeWithCodec_1.getTypeWithCodecFragment)({
        name: instructionNode.dataArgs.name,
        manifest: dataArgsManifest,
        nameApi,
    });
}
exports.getInstructionDataFragment = getInstructionDataFragment;
//# sourceMappingURL=instructionData.js.map