"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getInstructionRemainingAccountsFragment = void 0;
const common_1 = require("./common");
function getInstructionRemainingAccountsFragment(scope) {
    const { remainingAccounts } = scope.instructionNode;
    if (!remainingAccounts)
        return (0, common_1.fragment)('');
    const isAsync = (remainingAccounts === null || remainingAccounts === void 0 ? void 0 : remainingAccounts.kind) === 'resolver' &&
        scope.asyncResolvers.includes(remainingAccounts.name);
    if (!scope.useAsync && isAsync)
        return (0, common_1.fragment)('');
    const remainingAccountsFragment = (0, common_1.fragmentFromTemplate)('instructionRemainingAccounts.njk', {
        remainingAccounts,
        awaitKeyword: scope.useAsync && isAsync ? 'await ' : '',
        nameApi: scope.nameApi,
    }).addImports('solanaInstructions', ['IAccountMeta']);
    if ((remainingAccounts === null || remainingAccounts === void 0 ? void 0 : remainingAccounts.kind) === 'arg') {
        remainingAccountsFragment.addImports('solanaInstructions', ['AccountRole']);
    }
    else if ((remainingAccounts === null || remainingAccounts === void 0 ? void 0 : remainingAccounts.kind) === 'resolver') {
        const functionName = scope.nameApi.resolverFunction(remainingAccounts.name);
        remainingAccountsFragment
            .addImports(remainingAccounts.importFrom, functionName)
            .addFeatures(['instruction:resolverScopeVariable']);
    }
    return remainingAccountsFragment;
}
exports.getInstructionRemainingAccountsFragment = getInstructionRemainingAccountsFragment;
//# sourceMappingURL=instructionRemainingAccounts.js.map