export type NameTransformerHelpers = {
    capitalize: (name: string) => string;
    titleCase: (name: string) => string;
    pascalCase: (name: string) => string;
    camelCase: (name: string) => string;
    kebabCase: (name: string) => string;
    snakeCase: (name: string) => string;
};
export type NameTransformer = (name: string, helpers: NameTransformerHelpers) => string;
export type NameTransformerKey = 'dataType' | 'dataArgsType' | 'encoderFunction' | 'decoderFunction' | 'codecFunction' | 'accountType' | 'accountSeedsType' | 'accountDecodeFunction' | 'accountFetchFunction' | 'accountFetchAllFunction' | 'accountSafeFetchFunction' | 'accountSafeFetchAllFunction' | 'accountFindPdaFunction' | 'accountFetchFromSeedsFunction' | 'accountSafeFetchFromSeedsFunction' | 'accountGetSizeFunction' | 'dataEnumFunction' | 'isDataEnumFunction' | 'instructionAsyncInputType' | 'instructionAsyncInputWithSignersType' | 'instructionSyncInputType' | 'instructionSyncInputWithSignersType' | 'instructionType' | 'instructionWithSignersType' | 'instructionAsyncFunction' | 'instructionSyncFunction' | 'instructionRawFunction' | 'instructionParsedType' | 'instructionParseFunction' | 'programType' | 'programAddressConstant' | 'programCreateFunction' | 'programErrorClass' | 'programErrorCodeEnum' | 'programErrorCodeMap' | 'programGetErrorFromCodeFunction' | 'resolverFunction';
export type NameTransformers = Record<NameTransformerKey, NameTransformer>;
export type NameApi = Record<NameTransformerKey, (name: string) => string>;
export declare function getNameApi(transformers: NameTransformers): NameApi;
export declare const DEFAULT_NAME_TRANSFORMERS: NameTransformers;
